
set echo on

CREATE TABLE thousand_rows
AS
   SELECT ROWNUM           AS n1
   ,      RPAD('x',50,'x') AS v1
   FROM   dual
   CONNECT BY ROWNUM <= 1000;

BEGIN
   DBMS_STATS.GATHER_TABLE_STATS(user, 'THOUSAND_ROWS');
END;
/

CREATE FUNCTION some_function (
                p_id IN INTEGER
                ) RETURN INTEGER AS
BEGIN
   RETURN 0;
END some_function;
/

set autotrace traceonly explain

ALTER SESSION SET EVENTS '10053 trace name context forever, level 1';

SELECT *
FROM   thousand_rows
WHERE  some_function(n1) = 0;

ALTER SESSION SET EVENTS '10053 trace name context off';

set autotrace off


