
set echo on

CREATE FUNCTION quick_function (
                p_id IN INTEGER
                ) RETURN INTEGER AS
BEGIN
   RETURN MOD(p_id, 1000);
END quick_function;
/

CREATE FUNCTION slow_function (
                p_id IN INTEGER
                ) RETURN INTEGER AS
BEGIN
   DBMS_LOCK.SLEEP(0.005);
   RETURN MOD(p_id, 2);
END slow_function;
/

set autotrace traceonly 

set timing on

SELECT *
FROM   thousand_rows
WHERE  quick_function(n1) = 0
AND    slow_function(n1) = 0;

SELECT *
FROM   thousand_rows
WHERE  slow_function(n1) = 0
AND    quick_function(n1) = 0;

set timing off

set autotrace off

