
set echo on

CREATE FUNCTION promo_function(
                p_promo_category IN VARCHAR2
                ) RETURN VARCHAR2 IS
BEGIN
   RETURN UPPER(p_promo_category);
END promo_function;
/

set autotrace traceonly explain 

SELECT *
FROM   sh.sales       s
,      sh.promotions  p
,      sh.times       t
WHERE  s.promo_id = p.promo_id
AND    s.time_id = t.time_id
AND    t.time_id BETWEEN DATE '2000-01-01' AND DATE '2000-03-31'
AND    promo_function(p.promo_category) = 'TV';

set autotrace off

SELECT promo_category
,      ROUND(RATIO_TO_REPORT(c) OVER () * 100, 1) AS selectivity
FROM  (
       SELECT promo_category
       ,      COUNT(*) AS c
       FROM   sh.promotions
       GROUP  BY
              promo_category
      )
ORDER  BY
       2;

ASSOCIATE STATISTICS WITH FUNCTIONS promo_function 
   DEFAULT COST (100000, 0, 0)
   DEFAULT SELECTIVITY 23;

@flush SH.PROMOTIONS

set autotrace traceonly explain 

SELECT *
FROM   sh.sales       s
,      sh.promotions  p
,      sh.times       t
WHERE  s.promo_id = p.promo_id
AND    s.time_id = t.time_id
AND    t.time_id BETWEEN DATE '2000-01-01' AND DATE '2000-03-31'
AND    promo_function(p.promo_category) = 'TV';

set autotrace off

