
set echo on
col name format a20

CREATE FUNCTION cached_function(
                p_input IN INTEGER
                ) RETURN INTEGER RESULT_CACHE IS
BEGIN
   RETURN p_input + 100;
END cached_function;
/

CREATE FUNCTION uncached_function(
                p_input IN INTEGER
                ) RETURN INTEGER IS
BEGIN
   RETURN p_input + 100;
END uncached_function;
/

set autotrace traceonly explain
SELECT *
FROM   thousand_rows
WHERE  uncached_function(n1) > 900
AND    cached_function(n1) > 900;
set autotrace off

ASSOCIATE STATISTICS WITH FUNCTIONS cached_function, uncached_function 
   DEFAULT SELECTIVITY 20
   DEFAULT COST (100000, 100000, 0);

@flush thousand_rows

set autotrace traceonly explain
SELECT *
FROM   thousand_rows
WHERE  uncached_function(n1) > 900
AND    cached_function(n1) > 900;
set autotrace off

DISASSOCIATE STATISTICS FROM FUNCTIONS cached_function, uncached_function;

